unit fPrvRel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls, Quickrpt, QRprntr, QRExport, Printers;

type
  TfrmPrvRel = class(TForm)
    pnlHeader: TPanel;
    QRPreview1: TQRPreview;
    pnlFooter: TPanel;
    lblPaginas: TLabel;
    pgbUpdate: TProgressBar;
    edtPgIni: TEdit;
    edtPgFim: TEdit;
    lblPgIni: TLabel;
    lblPgFim: TLabel;
    lblPgAtual: TLabel;
    edtPgAtual: TEdit;
    lblZoom: TLabel;
    edtZoom: TEdit;
    SaveDialogExport: TSaveDialog;
    btnInicio: TBitBtn;
    btnAnterior: TBitBtn;
    btnProxima: TBitBtn;
    btnFinal: TBitBtn;
    btnMaisZoom: TBitBtn;
    btnMenosZoom: TBitBtn;
    btnCfgImp: TBitBtn;
    btnImprimir: TBitBtn;
    btnFechar: TBitBtn;
    btnGravar: TBitBtn;
    btnRestaurar: TBitBtn;
    lblTCopias: TLabel;
    edtCopias: TEdit;
    QRPreview2: TQRPreview;
    ckb2Painel: TCheckBox;
    splDivisa: TSplitter;
    btnPrtAtual: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure QRPreview1ProgressUpdate(Sender: TObject; Progress: Integer);
    procedure QRPreview1PageAvailable(Sender: TObject; PageNum: Integer);
    procedure edtPgAtualChange(Sender: TObject);
    procedure btnProximaClick(Sender: TObject);
    procedure btnAnteriorClick(Sender: TObject);
    procedure btnInicioClick(Sender: TObject);
    procedure btnFinalClick(Sender: TObject);
    procedure edtZoomChange(Sender: TObject);
    procedure btnMaisZoomClick(Sender: TObject);
    procedure btnMenosZoomClick(Sender: TObject);
    procedure btnCfgImpClick(Sender: TObject);
    procedure btnImprimirClick(Sender: TObject);
    procedure btnFecharClick(Sender: TObject);
    procedure btnGravarClick(Sender: TObject);
    procedure btnRestaurarClick(Sender: TObject);
    procedure ManuseiaBotoes( lAcao : Boolean );
    procedure QRPreview1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MovePainel2( X, Y: Integer);
    procedure ckb2PainelClick(Sender: TObject);
    procedure splDivisaCanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure splDivisaMoved(Sender: TObject);
    procedure btnPrtAtualClick(Sender: TObject);
  private
    nH2, nV2 : Integer;
    { Private declarations }
    procedure WMSysCommand(var Message: TWMSysCommand); message WM_SYSCOMMAND;
    procedure Init;
  public
    { Public declarations }
    pQuickreport : TQuickRep;
    bPleaseInit : Boolean;
  end;

var
  frmPrvRel: TfrmPrvRel;

implementation

{$R *.DFM}

procedure TfrmPrvRel.WMSysCommand( var Message: TWMSysCommand );
begin
  if ( message.CmdType and $FFF0 = SC_MINIMIZE ) then
     Application.Minimize
  else
    inherited;
end;

procedure TfrmPrvRel.FormShow(Sender: TObject);
begin
  Self.SetBounds( Screen.DesktopLeft,
                  Screen.DesktopTop,
                  Screen.DesktopWidth,
                  Screen.DesktopHeight );
  bPleaseInit := True;
  nH2 := 0;
  nV2 := 0;
end;

procedure TfrmPrvRel.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  QRPreview1.QRPrinter := nil;
  Action := caFree;
end;

procedure TfrmPrvRel.FormActivate(Sender: TObject);
begin
  splDivisa.Visible := False;
  pgbUpdate.Position := 0;
  edtCopias.Text     := IntToStr( pQuickReport.PrinterSettings.Copies );
end;

procedure TfrmPrvRel.btnFecharClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmPrvRel.Init;
begin
  if bPleaseInit then
     begin
       if pQuickReport.Page.Orientation = poLandscape then
          edtZoom.Text := '70'
       else
          edtZoom.Text := '100';
       QRPreview1.Zoom := StrToInt( edtZoom.Text );
       edtPgAtual.Text := '1';
       edtZoom.Text    := IntToStr( QRPreview1.Zoom );
       bPleaseInit     := False;
     end;
end;

procedure TfrmPrvRel.ManuseiaBotoes( lAcao : Boolean );
begin
  btnInicio.Enabled    := lAcao;
  btnAnterior.Enabled  := lAcao;
  btnProxima.Enabled   := lAcao;
  btnFinal.Enabled     := lAcao;
  btnMaisZoom.Enabled  := lAcao;
  btnMenosZoom.Enabled := lAcao;
  btnCfgImp.Enabled    := lAcao;
  btnPrtAtual.Enabled  := lAcao;
  btnImprimir.Enabled  := lAcao;
  btnGravar.Enabled    := lAcao;
  btnRestaurar.Enabled := lAcao;
end;

procedure TfrmPrvRel.QRPreview1ProgressUpdate(Sender: TObject; Progress: Integer);
var
  nTotPage : Integer;
begin
  if pgbUpdate.Position = 0 then
     begin
       ManuseiaBotoes( False );
       pgbUpdate.Visible    := True;
     end;
  pgbUpdate.Position := Progress;
  if QRPreview1.QRPrinter.Status = mpFinished then
     begin
       pgbUpdate.Position := 100;
     end;  
  if pgbUpdate.Position = 100 then
     begin
       nTotPage             := QRPreview1.QRPrinter.PageCount;
       edtPgFim.Text        := IntToStr( nTotPage );
       lblPaginas.Caption   := 'Total : ' + IntToStr( nTotPage ) + ' pages';
       Application.ProcessMessages;
       ManuseiaBotoes( True );
       pgbUpdate.Visible    := False;
     end;
end;

procedure TfrmPrvRel.QRPreview1PageAvailable(Sender: TObject; PageNum: Integer);
var
  nUltPg : Integer;
begin
  nUltPg := StrToInt( edtPgFim.Text );
  if nUltPg = 1 then nUltPg := 0;
  if nUltPg < PageNum then nUltPg := PageNum;
  edtPgFim.Text := IntToStr( nUltPg );
  if nUltPg = 1 then
     begin
       edtPgIni.Text      := '1';
       lblPaginas.Caption := 'Total : 1 page';
     end
  else
     begin
       lblPaginas.Caption := 'Total : ' + IntToStr( nUltPg ) + ' pages';
     end;
  Init;
  if QRPreview1.QRPrinter.Status = mpFinished then
     begin
       QRPreview2.QRPrinter  := QRPreview1.QRPrinter;
       QRPreview2.PageNumber := QRPreview1.PageNumber;
       QRPreview2.Zoom       := 200;
     end;
end;

procedure TfrmPrvRel.btnPrtAtualClick(Sender: TObject);
begin
  //**
  edtPgIni.Text := edtPgAtual.Text;
  edtPgFim.Text := edtPgAtual.Text;
  btnImprimirClick( Self );
end;

procedure TfrmPrvRel.btnImprimirClick(Sender: TObject);
begin
  with pQuickReport do
    begin
      ManuseiaBotoes( False );
      //with QRPreview1.QRPrinter do
      //  begin
          PrinterSettings.Copies    := StrToInt( edtCopias.Text );
          PrinterSettings.FirstPage := StrToInt( edtPgIni.Text );
          PrinterSettings.LastPage  := StrToInt( edtPgFim.Text );
          Print;
          PrinterSettings.FirstPage := 0;
          PrinterSettings.LastPage  := 0;
      //  end;
      edtPgIni.Text  := '1';
      edtPgFim.Text  := IntToStr( QRPreview1.QRPrinter.PageCount );
      edtCopias.Text := '1';
      Application.MessageBox( 'Print sucessfuly !', 'Atention',
                        MB_OK+MB_ICONEXCLAMATION+MB_DEFBUTTON1+MB_APPLMODAL);
      ManuseiaBotoes( True );
    end;
end;

procedure TfrmPrvRel.btnCfgImpClick(Sender: TObject);
begin
  with pQuickReport do
    begin
      ManuseiaBotoes( False );
      PrinterSetup;
      ManuseiaBotoes( True );
    end;
end;

///////////////////////////////////////////////////////////////////////////////

procedure TfrmPrvRel.edtPgAtualChange(Sender: TObject);
var
  nPagina : Integer;
begin
  Application.ProcessMessages;
  nPagina := QRPreview1.PageNumber;
  if Trim( edtPgAtual.Text ) <> '' then nPagina := StrToInt( edtPgAtual.Text );
  if ( nPagina >= 1 ) and ( nPagina <= QRPreview1.QRPrinter.PageCount ) then
     begin
       QRPreview1.PageNumber := nPagina;
       QRPreview2.PageNumber := nPagina;
     end;
end;

procedure TfrmPrvRel.btnInicioClick(Sender: TObject);
begin
  Application.ProcessMessages;
  with QRPreview1 do
    begin
      PageNumber := 1;
      edtPgAtual.Text := IntToStr( PageNumBer );
    end;
  QRPreview2.PageNumber := 1;
end;

procedure TfrmPrvRel.btnAnteriorClick(Sender: TObject);
begin
  Application.ProcessMessages;
  with QRPreview1 do
    begin
      if PageNumber > 1 then PageNumber := PageNumber - 1;
      edtPgAtual.Text := IntToStr( PageNumBer );
    end;
  QRPreview2.PageNumber := QRPreview1.PageNumber;
end;

procedure TfrmPrvRel.btnProximaClick(Sender: TObject);
begin
  Application.ProcessMessages;
  with QRPreview1 do
    begin
      if PageNumber < QRPreview1.QRPrinter.PageCount then PageNumber := PageNumber + 1;
      edtPgAtual.Text := IntToStr( PageNumBer );
    end;
  QRPreview2.PageNumber := QRPreview1.PageNumber;
end;

procedure TfrmPrvRel.btnFinalClick(Sender: TObject);
begin
  Application.ProcessMessages;
  with QRPreview1 do
    begin
      PageNumber      := QRPrinter.PageCount;
      edtPgAtual.Text := IntToStr( PageNumBer );
    end;
  QRPreview2.PageNumber := QRPreview1.PageNumber;
end;

///////////////////////////////////////////////////////////////////////////////

procedure TfrmPrvRel.btnMaisZoomClick(Sender: TObject);
begin
  Application.ProcessMessages;
  with QRPreview1 do
    begin
      if Zoom < 200 then Zoom := Zoom + 10;
      if Zoom > 200 then Zoom := 200;
      edtZoom.Text := IntToStr( Zoom );
    end;
end;

procedure TfrmPrvRel.btnMenosZoomClick(Sender: TObject);
begin
  Application.ProcessMessages;
  with QRPreview1 do
    begin
      if Zoom > 40 then Zoom := Zoom - 10;
      if Zoom < 40 then Zoom := 40;
      edtZoom.Text := IntToStr( Zoom );
    end;
end;

procedure TfrmPrvRel.edtZoomChange(Sender: TObject);
var
  nZoom : Integer;
begin
  Application.ProcessMessages;
  nZoom := QRPreview1.Zoom;
  if Trim( edtZoom.Text ) <> '' then nZoom := StrToInt( edtZoom.Text );
  if ( nZoom >= 40 ) and ( nZoom <= 200 ) then
     QRPreview1.Zoom := nZoom;
end;

procedure TfrmPrvRel.btnGravarClick(Sender: TObject);
var
  aExportFilter : TQRExportFilter;
begin
  aExportFilter := nil;
  with TSaveDialog.Create(Application) do
    try
      Filter := QRExportFilterLibrary.SaveDialogFilterString;
      if Execute then
         begin
           if FilterIndex = 1 then
              begin
                if Pos('.', Filename) = 0 then Filename := Filename + '.qrp';
                QRPreview1.QRPrinter.Save(Filename);
              end
           else
              begin
                try
                  aExportFilter := TQRExportFilterLibraryEntry(
                    QRExportFilterLibrary.Filters[FilterIndex - 2]).ExportFilterClass.Create(Filename);
                  QRPreview1.QRPrinter.ExportToFilter(aExportFilter);
                finally
                  aExportFilter.Free
                end
              end
         end;
    finally
      Free;
    end;
end;

procedure TfrmPrvRel.btnRestaurarClick(Sender: TObject);
var
  nTotPage : Integer;
begin
  with TOpenDialog.Create(Application) do
  try
    Filter := 'QuickReport files (*.qrp)|*.qrp';
    if Execute then
      if FileExists(FileName) then
         begin
           with QRPreview1 do
             begin
               QRPrinter.Load(Filename);
               PageNumber              := 1;
               PreviewImage.PageNumber := 1;
               edtPgAtual.Text         := IntToStr( PageNumBer );
               nTotPage                := QRPrinter.PageCount;
               edtPgFim.Text           := IntToStr( nTotPage );
               lblPaginas.Caption      := 'Total : ' + IntToStr( nTotPage ) + ' pages';
               if QRPrinter.Title = '' then QRPrinter.Title := Filename;
             end;
           bPleaseInit := True;
           Init;
         end
      else
         ShowMessage( 'Sorry, Not possible to restore file: ' + FileName);
  finally
    free;
  end;

end;

procedure TfrmPrvRel.QRPreview1MouseDown( Sender: TObject; Button: TMouseButton;
                                          Shift: TShiftState; X, Y: Integer);
begin
  MovePainel2( X, Y );
end;

procedure TfrmPrvRel.MovePainel2( X, Y: Integer);
var
  nRangeV1, nRangeH1 : Integer;
  nX2, nY2, nRangeV2, nRangeH2, nPosH2, nPosV2 : Integer;
  nPropRH, nPropRV : Double;
begin

  if QRPreview2.Visible then
     begin

       nPosH2 := 0;
       nPosV2 := 0;
       with QRPreview1 do
         begin
           nRangeH1 := HorzScrollBar.Range;
           nRangeV1 := VertScrollBar.Range;
         end;
       with QRPreview2 do
         begin
           nRangeH2 := HorzScrollBar.Range;
           nRangeV2 := VertScrollBar.Range;
         end;

       nPropRV := ( nRangeV2 / nRangeV1 ); // Proporo Vert entre Range 1 e 2
       nPropRH := ( nRangeH2 / nRangeH1 ); // Proporo Horz entre Range 1 e 2

       nY2     := Round( Y * nPropRV );    // Calcula posio Y no Preview 2
       nX2     := Round( X * nPropRH );    // Calcula posio X no Preview 2

       with QRPreview1 do
         begin
           if Zoom >= 70 then
              begin
                nPosV2 := nY2 - 50;
                nPosH2 := nX2 - 300;
              end
           else
              begin
                if Zoom >= 60 then
                   begin
                     nPosV2 := nY2 - 30;
                     nPosH2 := nX2 - 290;
                   end
                else
                   if Zoom >= 50 then
                      begin
                        nPosV2 := nY2 - 20;
                        nPosH2 := nX2 - 280;
                      end
                   else
                      if Zoom >= 40 then
                         begin
                           nPosV2 := nY2 - 10;
                           nPosH2 := nX2 - 270;
                         end;
              end;
         end;

       nH2 := nPosH2;
       nV2 := nPosV2;

       with QRPreview2 do
         begin
           HorzScrollBar.Position := nH2;
           VertScrollBar.Position := nV2;
         end;

     end;
end;

procedure TfrmPrvRel.ckb2PainelClick(Sender: TObject);
begin
  QRPreview2.Visible := not QRPreview2.Visible;
  if QRPreview2.Visible then
     begin
       QRPreview1.Cursor := crCross;
       splDivisa.Align   := alTop;
       splDivisa.Align   := alBottom;
       splDivisa.Visible := True;
       QRPreview2.Height := 94;
     end
  else
     begin
       QRPreview1.Cursor := crDefault;
       splDivisa.Align   := alBottom;
       splDivisa.Align   := alTop;
       splDivisa.Visible := False;
     end;
  with QRPreview2 do
    begin
      HorzScrollBar.Position := 0;
      VertScrollBar.Position := 0;
    end;
end;

procedure TfrmPrvRel.splDivisaCanResize(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
begin
  with QRPreview2 do
    begin
      HorzScrollBar.Position := 0;
      VertScrollBar.Position := 0;
    end;
end;

procedure TfrmPrvRel.splDivisaMoved(Sender: TObject);
begin
  with QRPreview2 do
    begin
      HorzScrollBar.Position := nH2;
      VertScrollBar.Position := nV2;
    end;
end;

end.
